//+------------------------------------------------------------------+
//|                                                         Rect.mq5 |
//|                                           Copyright 2021, ernst. |
//|                                   https://www.mql5.com/en/pippod |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, ernst."
#property link      "https://www.mql5.com/en/pippod"
#property version   "1.00"
#property indicator_chart_window
//---
#include <ChartObjects\ChartObjectsShapes.mqh>
#include <ChartObjects\ChartObjectsTxtControls.mqh>
#include <Arrays\ArrayObj.mqh>
CArrayObj rects,corners;
long chartID=ChartID();
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   ChartSetInteger(chartID,CHART_EVENT_OBJECT_DELETE,true);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   if(id==CHARTEVENT_OBJECT_DRAG || id==CHARTEVENT_OBJECT_CHANGE) {
      if(ObjectGetInteger(chartID,sparam,OBJPROP_TYPE)==OBJ_RECTANGLE) {
//---
         CChartObjectRectangle *rect=new CChartObjectRectangle;
         const datetime time0=(datetime)ObjectGetInteger(chartID,sparam,OBJPROP_TIME,0);
         const double price0=ObjectGetDouble(chartID,sparam,OBJPROP_PRICE,0);
         const datetime time1=(datetime)ObjectGetInteger(chartID,sparam,OBJPROP_TIME,1);
         const double price1=ObjectGetDouble(chartID,sparam,OBJPROP_PRICE,1);
         rect.Create(chartID,sparam,0,time0,price0,time1,price1);
         rects.Add(rect);
//---
         datetime Time[]={time0,time1};
         double Price[]={price1,price0};
         string Corner[]={"LL","RU"};
         for(int i=0;i<2;i++) {
            CChartObjectText *corner=new CChartObjectText;
            corner.Create(chartID,sparam+Corner[i],0,Time[i],Price[i]);
            corner.Selectable(true);
            corner.Selected(rect.Selected());
            corner.Color(clrNONE);
            corners.Add(corner); }
//---
         ChartRedraw(chartID); } }
//---
   if(id==CHARTEVENT_OBJECT_DRAG) {
      if(ObjectGetInteger(chartID,sparam,OBJPROP_TYPE)==OBJ_TEXT) {
//---
         int total=rects.Total();
         CChartObjectRectangle *rect;
         for(int i=0;i<total;i++) {
            rect=rects.At(i);
            if(StringFind(rect.Name(),sparam)!=-1)
               break; }
//---
         total=corners.Total();
         for(int i=0;i<total;i++) {
            CChartObjectText *corner=corners.At(i);
            if(StringFind(corner.Name(),sparam)!=-1) {
               if(StringFind(corner.Name(),"RU")!=-1) {
                  rect.SetInteger(OBJPROP_TIME,1,corner.GetInteger(OBJPROP_TIME));
                  rect.SetDouble(OBJPROP_PRICE,0,corner.GetDouble(OBJPROP_PRICE)); }
               if(StringFind(corner.Name(),"LL")!=-1) {
                  rect.SetInteger(OBJPROP_TIME,0,corner.GetInteger(OBJPROP_TIME));
                  rect.SetDouble(OBJPROP_PRICE,1,corner.GetDouble(OBJPROP_PRICE)); } } } }
//---
         ChartRedraw(chartID); }         
//---
   if(id==CHARTEVENT_OBJECT_DELETE) {
      for(int i=0;i<corners.Total();i++) {
         CChartObjectText *corner=corners.At(i);
         if(StringFind(corner.Name(),sparam)!=-1) {
            corner.Delete();
            corners.Delete(i);
            i--; } }
//---
      ChartRedraw(chartID); }
  }
//+------------------------------------------------------------------+
